<?php
//--------------------------------------------------------------------
// *** AMnBO for BlognPlus***
// LAST UPDATE: 2015/07/11
// Version    : 1.02
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// control.php
//
//--------------------------------------------------------------------

$module_version = "1.01";

if (!$objBlognPlus->is_login) {
	header("Content-Type: text/html; charset=UTF-8");
	echo 'セッションエラー。管理画面に入りなおしてください。';
	exit;
} else {
	$configfile = BLOGN_MODDIR.$module_name.'/config.php';
	include ($configfile);
}

$menu = array("1" => "設定", "独自タグ", "インストール", "モジュール情報");
$loadtabs = "1";
switch($_POST["method"]) {
	case "set_api":
		$blogn_module_amnbo_apikey["public"] = htmlspecialchars($_POST["public"]);
		$blogn_module_amnbo_apikey["secret"] = htmlspecialchars($_POST["secret"]);
		$blogn_module_amnbo_amaid["0"] = amnbo_check_id($_POST["id"]);
		
		$blogn_module_amnbo_common["target"] = $_POST["target"] ? htmlspecialchars($_POST["target"]) : "_blank";
		$blogn_module_amnbo_common["icon"] = isset($_POST["icon"]) ? htmlspecialchars($_POST["icon"]) : "0";
		$blogn_module_amnbo_tool["refresh"] = htmlspecialchars($_POST["refresh"]);
		$blogn_module_amnbo_tool["pcoff"] = htmlspecialchars($_POST["pcoff"]);
		$blogn_module_amnbo_tool["txtoff"] = htmlspecialchars($_POST["txtoff"]);
		$blogn_module_amnbo_tool["format"] = htmlspecialchars($_POST["format"]);
		$blogn_module_amnbo_tool["width"] = htmlspecialchars($_POST["width"]);
		if ($blogn_module_amnbo_tool["format"] == "l" && $blogn_module_amnbo_tool["width"] < 36) $blogn_module_amnbo_tool["width"] = 36;
		if ($blogn_module_amnbo_tool["format"] == "m" && $blogn_module_amnbo_tool["width"] < 31) $blogn_module_amnbo_tool["width"] = 31;
		if (!preg_match("/^[A-Z0-9]{20}$/", $blogn_module_amnbo_apikey["public"])) {
			$blogn_module_amnbo_apikey["public"] = "";
		}		
		if (!preg_match("!^[+/A-Z0-9]{40}$!i", $blogn_module_amnbo_apikey["secret"])) {
			$blogn_module_amnbo_apikey["secret"] = "";
		}
		if (!$blogn_module_amnbo_amaid["0"]) {
		}
		if (!$message) {
			amnbo_write_config($blogn_module_amnbo_amaid, $blogn_module_amnbo_apikey, $blogn_module_amnbo_common, $blogn_module_amnbo_tool);
			$message = '設定を変更しました。';
		} else {
			$message = '未入力の項目があります。';
		}
		break;
	default :
		$loadtabs = "1";
		break;
}

$setting = array();
$setting["target"][$blogn_module_amnbo_common["target"]] = ' checked="checked"';
$setting["refresh"]["tool"][$blogn_module_amnbo_tool["refresh"]] = ' selected="selected"';
$setting["pcoff"]["tool"][$blogn_module_amnbo_tool["pcoff"]] = ' selected="selected"';
$setting["txtoff"]["tool"][$blogn_module_amnbo_tool["txtoff"]] = ' selected="selected"';
$setting["format"][$blogn_module_amnbo_tool["format"]]["sel"] = ' selected="selected"';
$setting["format"]["width"][$blogn_module_amnbo_tool["width"]] = ' selected="selected"';

include BLOGN_MODDIR.$module_name.'/menu.php';

echo $js.'
<div class="blogn_main">

<div class="wrapper">
<h1 class="mod-title">アメンボ for BlognPlus (ver'.$module_version.')</h1>

<!-- LEFT -->
<div class="coll">
<h2 class="coll-h2">メニュー</h2>
<ul class="coll-ul">';

module_control_list($menu);

echo '
</ul>
<noscript><p class="nojs">※ Javascript 無効<br />メニュー内のテキストリンクは機能しないので、● をクリックしてナビゲートしてください。</p></noscript>
<p class="credit">Powered by<br /><a href="http://i-njoy.net/blog/" target="_blank" class="credit-a">nJOY BLOG</a></p>
</div>
 
<!-- RIGHT -->
<div class="colr">

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("設定", $menu).'">
<div class="blogn_bar">設定</div>
<div class="mod">

<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'">
<input type="hidden" name="method" value="set_api" />
<table border="1" cellspacing="0" cellpadding="3" width="600" class="mod-table">
<tr><th colspan="2" bgcolor="#dcdcdc">Amazon Product Advertising API 設定</th></tr>
<tr><th>公開鍵（20文字）</th><td><input type="text" name="public" maxlength="20" value="'.$blogn_module_amnbo_apikey["public"].'" size="60" style="ime-mode:disabled;" /></td></tr>
<tr><th>秘密鍵（40文字）</th><td><input type="text" name="secret" maxlength="40" value="'.$blogn_module_amnbo_apikey["secret"].'" size="60" style="ime-mode:disabled;" /></td></tr>
<tr><th>アソシエイトID</th><td><input type="text" name="id" size="20" value="'.$blogn_module_amnbo_amaid[0].'" style="ime-mode:disabled;" />（例: amnbo-22）</td></tr>

<tr><th colspan="2" bgcolor="#dcdcdc">商品リンク設定</th></tr>
<tr><th>リンクの表示方法</th><td>
<input type="radio" name="target" value="_blank"'.$setting["target"]["_blank"].' /> 新規ウィンドウを開く 
<input type="radio" name="target" value="_top"'.$setting["target"]["_top"].' /> 同じウィンドウに表示
</td></tr>

<tr><th>キャッシュ更新間隔</th><td>
<select name="refresh">';
for ($i = 1; $i < 25; $i++) {
	echo '<option value="'.$i.'"'.$setting["refresh"]["tool"][$i].'>'.$i.'時間毎</option>';
}
echo '</select>（「1時間毎」→価格を表示）
</td></tr>
<tr><th>割引率（画像）</th><td>
<select name="pcoff">
<option value="0"'.$setting["pcoff"]["tool"][0].'>非表示</option>
<option value="1"'.$setting["pcoff"]["tool"][1].'>画像左下に表示</option>
<option value="2"'.$setting["pcoff"]["tool"][2].'>画像右下に表示</option>
</select>
</td></tr>

<tr><th>割引率（テキスト）</th><td>
<select name="txtoff">
<option value="0"'.$setting["txtoff"]["tool"][0].'>非表示</option>
<option value="1"'.$setting["txtoff"]["tool"][1].'>価格横に表示</option>
</select>
</td></tr>

<tr><th>商品画像のサイズ</th><td>
<select name="format">
<option value="l"'.$setting["format"]["l"]["sel"].'>大（160x160px）</option>
<option value="m"'.$setting["format"]["m"]["sel"].'>中（120x120px）</option>
<option value="s"'.$setting["format"]["s"]["sel"].'>小（90x90px）</option>
</select>
</td></tr>

<tr><th>横幅</th><td>
<select name="width">';
for ($i = 28; $i < 61; $i++) {
	$j = $i * 10;
	echo '<option value="'.$i.'"'.$setting["format"]["width"][$i].'>'.$j.'</option>';
}
echo '</select> px (小: 280～、中: 310～、大: 360～）
</td></tr>

</table>
<input type="submit" value="設定" />
<span class="message">'.$message.'</span>
</form>
</div>

<hr class="divider" />
</div>


<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("独自タグ", $menu).'">
<div class="blogn_bar">独自タグ</div>
<div class="mod">

<h2 class="mod-h2">このモジュールで使える独自タグ</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500" class="mod-table">
<tr bgcolor="#dcdcdc"><th width="100">独自タグ</th><th>説明</th><th width="50">補足</th></tr>
<tr><td>[:ASIN:**********:]</td><td>********** = 商品の ISBN-10（本）か ASIN（本以外）</td><td>必須</td></tr>
</table>

<h2 class="mod-h2">このモジュールで出力するスタイルシート用クラス</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500" class="mod-table">
<tr bgcolor="#dcdcdc"><th width="100">クラス名</th><th>説明</th><th width="50">HTML</th><th width="50">補足</th></tr>
<tr><td>amnbo-tool</td><td>インラインフレーム</td><td>iframe</td><td>-</td></tr>
</table>

</div>
<hr class="divider" />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("インストール", $menu).'">
<div class="blogn_bar">インストール</div>
<div class="mod">

<h2 class="mod-h2">インストール方法</h2>
<ol class="mod-list">
<li>「config.php」のパーミッションを「666」等に変更する。</li>
<li>/tool/ ディレクトリのパーミッションを「777」等にする</li>
<li>「index.php」を改造する。</li>
<li>モジュール管理画面から動作スイッチを ON にする必要があります。</li>
</ol>

<h3 class="mod-h3">■ 「index.php」の改造</h3>
<p class="mod-p">「index.php」383行目あたり（v2.6.8の場合）に1行追加する。</p>
<pre class="code">
$blogn_skin = str_replace ("{TOKEN}", $blogn_token, $blogn_skin);

<b class="red">if ($blogn_mod_amnbo_flag) include(BLOGN_MODDIR."/amnbo/amazon.php");</b>

//-------------------------------------------------------------------- HTML出力処理
</pre>

</div>

<hr class="divider" />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("モジュール情報", $menu).'">
<div class="blogn_bar">モジュール情報</div>
<div class="mod">

<h2 class="mod-h2">公式サイト</h2>
<p class="mod-p">もっと詳しい情報や最新版モジュールのダウンロードは「<a href="http://i-njoy.net/tips/plus_amnb.shtml" target="_blank">アメンボ for BlognPlus</a>」の解説ページからどうぞ。</p>
<p class="mod-p">最新情報は「<a href="http://i-njoy.net/blog/" target="_blank">nJOY BLOG</a>」から入手できます。</p>

<h2 class="mod-h2">モジュール構成ファイル</h2>
<ul class="package">
<li class="pac-0">+ blognplus /</li>
<li class="pack-1">+ module /</li>
<li class="pack-2">+ amnbo /</li>
<li class="pack-3">- a_function.php</li>
<li class="pack-3">- amazon.php</li>
<li class="pack-3">- <span class="red">config.php</span></li>
<li class="pack-3">- control.php</li>
<li class="pack-3">- i_function.php</li>
<li class="pack-3">- index.html</li>
<li class="pack-3">- info.php</li>
<li class="pack-3">- install.php</li>
<li class="pack-3">- menu.php</li>
<li class="pack-3">- style.php</li>
<li class="pack-3">- tool.php</li>
<li class="pack-3">- uninstall.php</li>
<li class="pack-3">- update.php</li>
<li class="pack-3">- xml.php</li>
<li class="pack-3">+ css /</li>
<li class="pack-3">+ img /</li>
<li class="pack-3">+ <span class="blue">tool</span> /</li>
</ul>

<p class="mod-p"><span class="red">config.php</span>のパーミッションは「666」や「606」に変更してください。<br /><span class="blue">tool</span> ディレクトリのパーミッションは「777」等に変更してください。</p>

<h2 class="mod-h2">動作 ON/OFF</h2>
<p class="mod-p">モジュールをインストール後に、動作のオン・オフを切り替える必要があります。</p>
<dl class="mod-dl">
<dt>PC</dt><dd>「PC」欄を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
<dt>携帯</dt><dd>「携帯」欄 を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
</dl>

<h2 class="mod-h2">優先順位</h2>
<p class="mod-p">特に制限はありません。</p>

</div>
<hr class="divider" />
</div>


</div>
</div>
</div>';

function amnbo_write_config($ids, $apikey, $common, $tool) {
	$configfile = BLOGN_MODDIR.'amnbo/config.php';

	$hash = (function_exists(hash_hmac)) ? "1" : "0";
	$xml = (function_exists(simplexml_load_string)) ? "1" : "0";
	if (is_array($ids)) {	
		foreach ($ids as $key => $value) {
			if ($value) $multi_id .= '"'.$key.'" => "'.$value.'", ';
		}
	}

	$str = '<?php
$blogn_module_amnbo_func["xml"] = "'.$xml.'";
$blogn_module_amnbo_func["hash"] = "'.$hash.'";
$blogn_module_amnbo_apikey["public"] = "'.$apikey["public"].'";
$blogn_module_amnbo_apikey["secret"] = "'.$apikey["secret"].'";
$blogn_module_amnbo_amaid = array('.$multi_id.');
$blogn_module_amnbo_common["target"] = "'.$common["target"].'";
$blogn_module_amnbo_common["icon"] = "'.$common["icon"].'";
$blogn_module_amnbo_tool["refresh"] = "'.$tool["refresh"].'";
$blogn_module_amnbo_tool["pcoff"] = "'.$tool["pcoff"].'";
$blogn_module_amnbo_tool["txtoff"] = "'.$tool["txtoff"].'";
$blogn_module_amnbo_tool["format"] = "'.$tool["format"].'";
$blogn_module_amnbo_tool["width"] = "'.$tool["width"].'";
?>';
	$fp = fopen($configfile, "w+");
	flock($fp, LOCK_EX);
	fwrite($fp, $str);
	flock($fp, LOCK_UN);
	fclose($fp);
}

function amnbo_check_id($id) {
	$id = htmlspecialchars($id);
	if (!preg_match("/([-_A-Z0-9]+-22,*)+$/i", $id)) {
		$id = "";
	}
	return $id;
}

?>
