<?php
//--------------------------------------------------------------------
// *** AMnBO for BlognPlus***
// LAST UPDATE: 2015/07/11
// Version    : 1.02
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// install.php
//
//--------------------------------------------------------------------

$mod = array(
	"ver"	=>	"1.02",
	"id"	=>	"amnbo",
	"name"	=>	"アメンボ for BlognPlus"
);

if (!$objBlognPlus->is_login) {
	header("Content-Type: text/html; charset=UTF-8");
	echo 'セッションエラー。管理画面に入りなおしてください。';
	exit;
}

$information = '
<div style="margin: 0 2em;">
<h2 style="color:#0000ff;font-size:120%;">'.$mod["name"].' ver'.$mod["ver"].'</h2>
<div style="border-left:2px solid #aaaaff;margin-left:2em;padding:0 2em;">
<p><span style="color:#008000">■</span> モジュールのインストールが完了しました。</p>
<p><span style="color:#ff0000">■</span> このモジュールの動作には「index.php」の改造が必要です。</p>';

// PC 動作 ON
$pc_on = blogn_mod_db_module_onoff($mod["id"], "pc", 1);
if (!$pc_on["0"] || $pc_on["0"] == true) {
	$information .= '<p><span style="color:#008000">■</span> 「PC」スイッチを <img src="'.BLOGN_HOMELINK.'images/on.gif" width="20" height="20" alt="ON" style="vertical-align:middle;" /> に切り替えました。</p>';
}

// 携帯 動作 ON
$mob_on = blogn_mod_db_module_onoff($mod["id"], "mobile", 1);
if (!$mob_on["0"] || $mob_on["0"] == true) {
	$information .= '<p><span style="color:#008000">■</span> 「携帯」スイッチを <img src="'.BLOGN_HOMELINK.'images/on.gif" width="20" height="20" alt="ON" style="vertical-align:middle;" /> に切り替えました。</p>';
}

// ディレクトリに書き込めるかチェック
$filedir = BLOGN_MODDIR.$mod["id"].'/tool';
if (!is_writable($filedir)) {
	$information .= '<p><span style="color:#ff0000">■</span> /'.$mod["id"].'/tool/ ディレクトリのパーミッションに書き込み属性を与えてください（「777」「707」等）。</p>';
} else {
	$information .= '<p><span style="color:#008000">■</span> /'.$mod["id"].'/tool/ ディレクトリのパーミッション OK</p>';
}

// ファイルに書き込めるかチェック
$filename = BLOGN_MODDIR.$mod["id"].'/config.php';
if (!is_writable($filename)) {
	$information .= '<p><span style="color:#ff0000">■</span> /'.$mod["id"].'/config.php のパーミッションに書き込み属性を与えてください（「666」「606」等）。</p>';
} else {
	$information .= '<p><span style="color:#008000">■</span> /'.$mod["id"].'/config.php のパーミッション OK</p>';
}

$information .= '
<h3>設定</h3>
<ul style="line-height:150%;">
<li><b>優先順位</b>: 特に制限はありません。</li>
<li><b>動作 ON/OFF</b>: 「PC」「携帯」の動作 ON/OFF 欄を <img src="'.BLOGN_HOMELINK.'images/on.gif" width="20" height="20" alt="ON" style="vertical-align:middle;" /> にして使ってください。</li>
<li><b>キャッシュ</b>: 非対応</li>
</ul>
</div>
</div>';

?>
